/************************************************************************
** Copyright (C) 1987, Fujitsu LTD. (Itaru ICHIKAWA)
** $BO"Mm@h!'(J $B!J3t!KIY;NDL8&5f=j!!%=%U%H#38&!!;T@n!!;j(J 
** $B!J(JE-Mail Address: ichikawa@flab.fujitsu.co.jp$B!K(J
**	$B1DMx$rL\E*$H$7$J$$8B$j!"$3$N%=!<%9$N$$$+$J$k(J
**	$BJ#<L!$2~JQ!$=$@5$b5vBz$7$^$9!#$=$N:]$K$O!"$3$NItJ,$r;D$9$3$H!#(J
**	$B$3$N%W%m%0%i%`$K$D$$$F$OFC$K2?$NJ]>Z$b$7$J$$!"0-$7$+$i$:!#(J
**	Everyone is permitted to do anything on this program 
**	including copying, modifying, improving 
**	as long as you don't try to make money off it, 
**	or pretend that you wrote it.
**	i.e., the above copyright notice has to appear in all copies.
**	THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE.
***********************************************************************/
static char *CopyRight =
	"Copyright (C) 1987, FUJITSU LTD. (I.Ichikawa)";
/***********************************************************************
**	
**					 Written by I.Ichikawa
**					 Fujitsu Labs.,  JH2FKN/1
**
**	hacked into a c library by Patrick Baltz <patrick.baltz@sfbay.sun.com>
**	Sun Microsystems
**
**   Very simple, basically does what nkf does except in library form.
**   Don't know if it has full functionality, but hopefully eventually.
**
**   The interface to use.  All three functions take in a char * and encodes it
**   in the specified kanji encoding, returning a char * to a newly allocated
**   char * that will need to be freed.
** 
**   char * string = convert_to_jis(char*);  Convert to JIS.
**   char * string = convert_to_sjis(char*); Convert to Shift-JIS.
**   char * string = convert_to_euc(char*);  Convert to EUC
**   char * new_string = convert_encoding(char*, char*to_encoding, char *from_encoding);  Convert using iconv with known encodings.
**
**   I don't recommend using anything other than the above three functions.
**   There is no guarantee that the underlying code won't change, especially
**   due to the time constraints of porting this into a library.
**
************************************************************************/
#ifndef __NKF_LIBRARY_H__
#define __NKF_LIBRARY_H__

#include <glib.h>

#define		ESC	0x1b
#define		SP	0x20
#define		AT	0x40
#define		SSP	0xa0
#define		DEL	0x7f

#define		HOLD_SIZE	32

#define		DEFAULT_KI	'@'
#define		DEFAULT_KO	'B'
#define		DEFAULT_I	oconv		/* EUC, JIS7 */
/* #define	DEFAULT_I	s_oconv		Shift JIS */

#define		SJ0162	0x00e1		/* 01 - 62 ku offset */
#define		SJ6394	0x0161		/* 63 - 94 ku offset */




/* buffers */
short           hold_buf[HOLD_SIZE];
int             hold_count;

/* flags */
int	estab_f;

/* options */
char            k_in,
                k_out;

/* here is the API to use with this library */
char * convert_to_jis(char*);  /* convert to jis7 */
char * convert_to_sjis(char*); /* convert to sjis */
char * convert_to_euc(char*);  /* convert to euc (at&t) */
char * convert_encoding(char*, char*, char*); /* convert using iconv */

/* everything below here should be considered private, use the API functions */

/* converters */
char 	*s_iconv (int, int);

char 	*e_oconv (int, int);
char 	*j_oconv (int, int);
char	*s_oconv (int, int);

unsigned int		rot13 ();
unsigned int		rot47 ();
unsigned int		nops ();

char 	*(*nkf_iconv) ();
unsigned int		(*r1conv) ();
unsigned int		(*r2conv) ();
char 	*(*oconv) ();

/* pre-declare these to avoid confusing gcc */
char 	*h_conv(char *, int, int);
char	*__convert_encoding(char *);

/* Global states */
int             in_kanji,
                k_shift;

#endif
